#Group Component active_model?
#1.00
#Group Component
#
#
#ZH.F@zzu.edu.cn
#20070104
require "sketchup.rb"

class ExtractEnts 
  def activate
    Sketchup.active_model.start_operation "ExtractEnts"
    @model=Sketchup.active_model
    @selection=@model.selection
    @entities=@model.entities
    if @selection.empty? or  @selection[0].parent == @model then
      UI.messagebox "Select entities in goup or componet!", MB_OK , "Error"
      @model.select_tool nil
    end
    entities=[]
    @selection.each{|i| entities << i}
    self.clone_entities(entities)
    Sketchup.active_model.commit_operation
    Sketchup.active_model.select_tool nil
  end
 
  def clone_entities(entities)
    ents=[]
    entities.each{|i|
      case i.typename
      when "Edge"       
        if   (i.curve)
          ents << i.curve
        else          
          ents << i
        end
      when "Face"
        ents << i
      when "Group"
        es=i.copy.explode
        self.clone_entities es
        puts "11111"  
        es.each{|i| i.erase! if i.valid? and ["Edge","Face"].include?( i.typename )}    
        end
      }
      ents=ents & ents   
      ents.each{|i|
        case i.typename
        when "Edge"
          @entities.add_edges i.vertices.map!{|i| i.position}
        when "Curve"
          @entities.add_curve i.vertices.map!{|i| i.position}
        when "ArcCurve"       
          @entities.add_arc i.center,i.xaxis,i.normal,i.radius,i.start_angle,i.end_angle
        when "Face"
          self.add_face i
        end
      }
    end
    def add_face_by_loop(loop)
      ver=[]
      loop.vertices.each{|i| ver<< (i.position)}
      @entities.add_face ver
    end
    def add_face(face)
      add_face_by_loop(face.outer_loop)
      loops=face.loops
      loops.delete( face.outer_loop)
      loops.each{|i| @entities.erase_entities  add_face_by_loop(i)}
    end
   
  end
  def extractEntsCanRun?
    ss=Sketchup.active_model.selection
    return nil if ss.empty? or ss[0].parent == Sketchup.active_model
    true
  end
 
  ##
  if( not file_loaded?("ExtractEnts.rb") )
    #
    UI.menu("Plugins").add_item("Estrac ents") { Sketchup.active_model.select_tool ExtractEnts.new }
    #
    UI.add_context_menu_handler do | menu |
      if extractEntsCanRun? then
        menu.add_separator
        menu.add_item("Estrac ents") { Sketchup.active_model.select_tool ExtractEnts.new }
      end
    end
  end
  file_loaded("ExtractEnts.rb")